加载中...
665-非递减数列(Non-decreasing Array)
发表于:2021-12-03 | 分类: 中等
字数统计: 207 | 阅读时长: 1分钟 | 阅读量:

原文链接: https://leetcode-cn.com/problems/non-decreasing-array

英文原文

Given an array nums with n integers, your task is to check if it could become non-decreasing by modifying at most one element.

We define an array is non-decreasing if nums[i] <= nums[i + 1] holds for every i (0-based) such that (0 <= i <= n - 2).

 

Example 1:

Input: nums = [4,2,3]
Output: true
Explanation: You could modify the first 4 to 1 to get a non-decreasing array.

Example 2:

Input: nums = [4,2,1]
Output: false
Explanation: You can't get a non-decreasing array by modify at most one element.

 

Constraints:

  • n == nums.length
  • 1 <= n <= 104
  • -105 <= nums[i] <= 105

中文题目

给你一个长度为 n 的整数数组,请你判断在 最多 改变 1 个元素的情况下,该数组能否变成一个非递减数列。

我们是这样定义一个非递减数列的: 对于数组中任意的 i (0 <= i <= n-2),总满足 nums[i] <= nums[i + 1]

 

示例 1:

输入: nums = [4,2,3]
输出: true
解释: 你可以通过把第一个4变成1来使得它成为一个非递减数列。

示例 2:

输入: nums = [4,2,1]
输出: false
解释: 你不能在只改变一个元素的情况下将其变为非递减数列。

 

提示:

  • 1 <= n <= 10 ^ 4
  • - 10 ^ 5 <= nums[i] <= 10 ^ 5

通过代码

高赞题解

各位题友大家好,今天是负雪明烛坚持日更的第 14 天。今天力扣上的每日一题是「665. 非递减数列」。

解题思路

一、错误代码

拿到今天这个题,看到是个 Easy,就没有想太多了。直接判断是不是只出现了一次下降!迅速写出下面的代码,题目给的两个测试用例都通过了,那么就提交!

没想到,啪!直接来了个解答错误,很快啊!

[]
class Solution(object): def checkPossibility(self, nums): count = 0 N = len(nums) for i in range(N): if i > 0 and nums[i] < nums[i - 1]: count += 1 return count <= 1

题目说该代码没有通过测试用例 [3,4,2,3] 。仔细一想还真是,虽然该数组中只出现了一次下降,但是无论调整其中的一个数字都不能得到一个单调上升的数组。

那么,这题就有讲究了。下面我举了例子,相信我,下面的分析不难,你看完一定能懂。

二、举例分析

首先,看下面的几个测试用例,它们都因为数字 2 的出现,导致数组是非单调递增的。

  • 例①: 4, 2, 5 
  • 例②: 1, 4, 2, 5
  • 例③: 3, 4, 2, 5

当数组中出现 2 时,破坏了数组的单调递增。为了让数组有序,我们需要对 2 或者 4 进行调整:

第①个用例,我们可以 把 4 调小到 <= 2  或者 把 2 调大到 4、5 ,使数组有序。

655-1.gif

第②个用例,我们可以 把 4 调小到 1、2  或者 把 2 调大到 4、5 ,使数组有序。

655-2.gif

第③个用例,我们必须 把 2 调大到 4、5,才能使数组有序:我们不能把 4 调整为一个 <= 2 的数字,因为 4 前面的元素是 3.

655-3.gif

三、归纳总结

nums[i] 破坏了数组的单调递增时,即 nums[i] < nums[i - 1]  时,为了让数组有序,我们发现一个规律(在上面三个例子中, nums[i] 都为 2, nums[i -1] 都为 4):

  1. 如例①的情况,当 i = 1 ,那么修改 num[i- 1] ,不要动 nums[i] ,因为nums[i]后面的元素是啥我们还不知道呢,少动它为妙。
  2. 如例②的情况,当 i > 1 时,我们应该优先考虑把 nums[i - 1] 调小到 >= nums[i - 2] 并且 <= nums[i]。同样尽量不去修改 nums[i] ,理由同上。
  3. 如例③的情况,当 i > 1nums[i] < nums[i - 2] 时,我们无法调整 nums[i - 1] ,我们只能调整 nums[i]nums[i - 1] 。

代码

使用 Python 和 C++ 写的代码如下。

[]
class Solution(object): def checkPossibility(self, nums): """ :type nums: List[int] :rtype: bool """ N = len(nums) count = 0 for i in range(1, N): if nums[i] < nums[i - 1]: count += 1 if i == 1 or nums[i] >= nums[i - 2]: nums[i - 1] = nums[i] else: nums[i] = nums[i - 1] return count <= 1
[]
class Solution { public: bool checkPossibility(vector<int>& nums) { int count = 0; for (int i = 1; i < nums.size(); i++) { if (nums[i] < nums[i - 1]) { if (i == 1 || nums[i] >= nums[i - 2]) { nums[i - 1] = nums[i]; } else { nums[i] = nums[i - 1]; } count ++; } } return count <= 1; } }

刷题心得

  1. 别小看 easy 题,它也能给我们带来收获,特别是easy题可能帮助我们练习某一种思路。
  2. 这题看分析那么一大截,其实只是当发现有下降的时候,多判断了一次 nums[i]nums[i - 2],本身没那么难。

OK,以上就是 @负雪明烛 写的今天题解的全部内容了,如果你觉得有帮助的话,求赞、求关注、求收藏。我们明天再见!

统计信息

通过次数 提交次数 AC比率
76975 284032 27.1%

提交历史

提交时间 提交结果 执行时间 内存消耗 语言
上一篇:
664-奇怪的打印机(Strange Printer)
下一篇:
667-优美的排列 II(Beautiful Arrangement II)
本文目录
本文目录